//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#pragma hdrstop
Graphics::TBitmap *Bitmap1;
Graphics::TBitmap *Bitmap2;
float M[3][3];

void Morph(float S[4][2], float D[4][2], float &x, float &y)
{
 float alfa,beta;
 float XA,YA,XB,YB,XC,YC,XD,YD;
 float W,Wx,Wy;

 alfa=(x-S[0][0])/(S[3][0]-S[0][0]);
 beta=(y-S[0][1])/(S[2][1]-S[0][1]);
 XA=D[0][0]+alfa*(D[3][0]-D[0][0]);
 XB=D[1][0]+alfa*(D[2][0]-D[1][0]);
 XC=D[0][0]+beta*(D[1][0]-D[0][0]);
 XD=D[3][0]+beta*(D[2][0]-D[3][0]);
 YA=D[0][1]+alfa*(D[3][1]-D[0][1]);
 YB=D[1][1]+alfa*(D[2][1]-D[1][1]);
 YC=D[0][1]+beta*(D[1][1]-D[0][1]);
 YD=D[3][1]+beta*(D[2][1]-D[3][1]);
 W=(YD-YC)*(XA-XB)-(YB-YA)*(XC-XD);
 Wx=(XC*YD-YC*XD)*(XA-XB)-(XA*YB-YA*XB)*(XC-XD);
 Wy=(YD-YC)*(XA*YB-YA*XB)-(YB-YA)*(XC*YD-YC*XD);
 x=Wx/W;
 y=Wy/W;
}

void ZeroM()
{
 M[0][0]=1;
 M[1][0]=0;
 M[2][0]=0;
 M[0][1]=0;
 M[1][1]=1;
 M[2][1]=0;
 M[0][2]=0;
 M[1][2]=0;
 M[2][2]=1;
}

void Transform(float &x, float &y)
{
 float xtmp,ytmp;
 xtmp=M[0][0]*x+M[1][0]*y+M[2][0];
 ytmp=M[0][1]*x+M[1][1]*y+M[2][1];
 x=xtmp; y=ytmp;
}

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
 Bitmap1 = new Graphics::TBitmap();
 Bitmap2 = new Graphics::TBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
 delete Bitmap1;
 delete Bitmap2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 Canvas->Draw(0,0,Bitmap1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Obrt1Click(TObject *Sender)
{
 Graphics::TBitmap *TmpBitmap = new Graphics::TBitmap();
 TmpBitmap->LoadFromFile("foto1.bmp ");
 Bitmap1->Assign(TmpBitmap);
 Bitmap1->Dormant();
 Bitmap1->FreeImage();
 delete TmpBitmap;
 Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rotate()
{
 int i,j;
 float x,y;
 ZeroM();
 M[1][0]=0.747;
 M[0][1]=-0.747;
 M[2][0]=-190;
 M[2][1]=90;
 Bitmap2->Width=800;
 Bitmap2->Height=800;
 for (i=0; i<800; i++)
  for (j=0; j<800; j++)
  {
   x=i; y=j;
   Transform(x,y);
   if ((x<0) || (x>Bitmap1->Width-1) || (y<0) || (y>Bitmap1->Height-1))
    Bitmap2->Canvas->Pixels[i][j]=clBlack;
   else
    Bitmap2->Canvas->Pixels[i][j]=Bitmap1->Canvas->Pixels[int(x+0.5)][int(y+0.5)];
  }
 Bitmap1->Width=Bitmap2->Width;
 Bitmap1->Height=Bitmap2->Height;
 Bitmap1->Canvas->Draw(0,0,Bitmap2);
 Invalidate();
}

void __fastcall TForm1::Skew()
{
 int i,j;
 float x,y;
 ZeroM();
 M[1][0]=0.25;
 M[2][0]=-90;
 Bitmap2->Width=800;
 Bitmap2->Height=800;
 for (i=0; i<800; i++)
  for (j=0; j<800; j++)
  {
   x=i; y=j;
   Transform(x,y);
   if ((x<0) || (x>Bitmap1->Width-1) || (y<0) || (y>Bitmap1->Height-1))
    Bitmap2->Canvas->Pixels[i][j]=clBlack;
   else
    Bitmap2->Canvas->Pixels[i][j]=Bitmap1->Canvas->Pixels[int(x+0.5)][int(y+0.5)];
  }
 Bitmap1->Width=Bitmap2->Width;
 Bitmap1->Height=Bitmap2->Height;
 Bitmap1->Canvas->Draw(0,0,Bitmap2);
 Invalidate();
}

void __fastcall TForm1::Obrt2Click(TObject *Sender)
{
 Rotate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Przekrzywienie1Click(TObject *Sender)
{
 Skew();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Perspektywa1Click(TObject *Sender)
{
 int i,j;
 float x,y;
 Bitmap2->Width=Bitmap1->Width;
 Bitmap2->Height=Bitmap1->Height;
 for (i=0; i<Bitmap1->Width; i++)
  for (j=0; j<Bitmap1->Height; j++)
  {
   x=i;
   y=150+800*float(j-150)/(800-i);
   if ((x<0) || (x>Bitmap1->Width-1) || (y<0) || (y>Bitmap1->Height-1))
    Bitmap2->Canvas->Pixels[i][j]=clBlack;
   else
    Bitmap2->Canvas->Pixels[i][j]=Bitmap1->Canvas->Pixels[int(x+0.5)][int(y+0.5)];
  }
 Bitmap1->Width=Bitmap2->Width;
 Bitmap1->Height=Bitmap2->Height;
 Bitmap1->Canvas->Draw(0,0,Bitmap2);
 Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Wydcie1Click(TObject *Sender)
{
 int i,j;
 float x,y,k,r;
 Bitmap2->Width=Bitmap1->Width;
 Bitmap2->Height=Bitmap1->Height;
 for (i=0; i<Bitmap1->Width; i++)
  for (j=0; j<Bitmap1->Height; j++)
  {
   r=sqrt((i-150)*(i-150)+(j-150)*(j-150))+10;
   k=100/r;
   x=150+(i-150)/k;
   y=150+(j-150)/k;
   if ((x<0) || (x>Bitmap1->Width-1) || (y<0) || (y>Bitmap1->Height-1))
    Bitmap2->Canvas->Pixels[i][j]=clBlack;
   else
    Bitmap2->Canvas->Pixels[i][j]=Bitmap1->Canvas->Pixels[int(x+0.5)][int(y+0.5)];
  }
 Bitmap1->Width=Bitmap2->Width;
 Bitmap1->Height=Bitmap2->Height;
 Bitmap1->Canvas->Draw(0,0,Bitmap2);
 Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Korekta1Click(TObject *Sender)
{
 float i,j;
 float x0,y0,x,y,r_src,r_dst;
 float a,b,c,d,cos,sin;

 a=0;
 b=0.00000001;
 c=0.00015;
 d=1;
 Bitmap2->Width=Bitmap1->Width;
 Bitmap2->Height=Bitmap1->Height;
 x0=Bitmap1->Width/2;
 y0=Bitmap1->Height/2;
 for (i=0; i<Bitmap1->Width; i+=0.5)
  for (j=0; j<Bitmap1->Height; j+=0.5)
  {
   r_dst=sqrt((i-x0)*(i-x0)+(j-y0)*(j-y0));
   if (r_dst==0)
   {
    x=i;
    y=j;
   }
   else
   {
    r_src=a*pow(r_dst,4)+b*pow(r_dst,3)+c*pow(r_dst,2)+d*r_dst;
    cos=(i-x0)/r_dst;
    sin=(j-y0)/r_dst;
    x=x0+r_src*cos;
    y=y0+r_src*sin;
   }
  Bitmap2->Canvas->Pixels[int(x+0.5)][int(y+0.5)]=Bitmap1->Canvas->Pixels[i][j];
 }
 Bitmap1->Width=Bitmap2->Width;
 Bitmap1->Height=Bitmap2->Height;
 Bitmap1->Canvas->Draw(0,0,Bitmap2);
 Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Zaaduj21Click(TObject *Sender)
{
 Graphics::TBitmap *TmpBitmap = new Graphics::TBitmap();
 TmpBitmap->LoadFromFile("foto2.bmp ");
 Bitmap1->Assign(TmpBitmap);
 Bitmap1->Dormant();
 Bitmap1->FreeImage();
 delete TmpBitmap;
 Invalidate();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Morfing1Click(TObject *Sender)
{
 float i,j;
 float Src[4][2];
 float Dest[4][2];
 float x,y;

 Bitmap2->Width=Bitmap1->Width;
 Bitmap2->Height=Bitmap1->Height;
 Src[0][0]=0;                   Src[0][1]=0;
 Src[1][0]=0;                   Src[1][1]=Bitmap1->Height;
 Src[2][0]=Bitmap1->Width;      Src[2][1]=Bitmap1->Height;
 Src[3][0]=Bitmap1->Width;      Src[3][1]=0;
 Dest[0][0]=40;                 Dest[0][1]=20;
 Dest[1][0]=200;                Dest[1][1]=Bitmap1->Height;
// Dest[2][0]=Bitmap1->Width-150; Dest[2][1]=Bitmap1->Height-60;
// Dest[3][0]=Bitmap1->Width;     Dest[3][1]=50;
 Dest[2][0]=Bitmap1->Width-150; Dest[2][1]=50;
 Dest[3][0]=Bitmap1->Width;     Dest[3][1]=Bitmap1->Height-60;
 for (i=0; i<Bitmap1->Width; i++)
  for (j=0; j<Bitmap1->Height; j++)
  {
   x=i;
   y=j;
   Morph(Src,Dest,x,y);
   Bitmap2->Canvas->Pixels[int(x+0.5)][int(y+0.5)]=Bitmap1->Canvas->Pixels[i][j];
  }
 Bitmap1->Width=Bitmap2->Width;
 Bitmap1->Height=Bitmap2->Height;
 Bitmap1->Canvas->Draw(0,0,Bitmap2);
 Invalidate();
}
//---------------------------------------------------------------------------

